export declare type LocaleDataMessages = {
    [key: string]: any;
    headers?: object;
    translations?: object;
} | null;
export declare type LocaleDataExtra = object | null;
export declare type LocaleData = {
    messages?: LocaleDataMessages;
    extra?: LocaleDataExtra;
};
export declare enum GettextFunctions {
    GETTEXT = "gettext",
    PGETTEXT = "pgettext",
    NGETTEXT = "ngettext",
    NPGETTEXT = "npgettext"
}
export declare type AliasObject = {
    [key in GettextFunctions]?: string;
};
export declare type Alias = string | AliasObject;
export declare type GetPluralForm = (n: number) => number;
export declare type LocalizedContext = {
    Provider: object;
};
export declare type Gettext = {
    (text: string): string;
    (inputs: TemplateStringsArray, ...values: any[]): string;
};
export declare type Pgettext = {
    (ctx: string, text: string): string;
    (ctx: string): (inputs: TemplateStringsArray, ...values: any[]) => string;
};
export declare type Ngettext = {
    (text: string, textPlural: string, n: number): string;
    (inputs: TemplateStringsArray, ...values: any[]): (inputsPlural: TemplateStringsArray, ...valuesPlural: any[]) => (n: number) => string;
};
export declare type Npgettext = {
    (ctx: string, text: string, textPlural: string, n: number): string;
    (ctx: string): (inputs: TemplateStringsArray, ...values: any[]) => (inputsPlural: TemplateStringsArray, ...valuesPlural: any[]) => (n: number) => string;
};
export declare type LocalizedContextValue = {
    [key: string]: any;
    [key: number]: any;
    locale: string;
    [GettextFunctions.GETTEXT]: Gettext;
    [GettextFunctions.PGETTEXT]: Pgettext;
    [GettextFunctions.NGETTEXT]: Ngettext;
    [GettextFunctions.NPGETTEXT]: Npgettext;
};
export interface CreateLocalizedContextOptions {
    createContext: any;
}
export interface CreateUseLocalesOptions {
    localizedContext: LocalizedContext;
    useContext: any;
}
export interface CreateWithLocalesOptions {
    useLocales: () => LocalizedContextValue;
    createElement: any;
    forwardRef: any;
}
export interface CreateLocalizedProviderOptions {
    localizedContext: LocalizedContext;
    createElement: any;
    useEffect: any;
    useState: any;
    useMemo: any;
}
export interface LocalizedProviderProps {
    children: (state: LocalizedProviderState) => any;
    locales?: {
        [key: string]: LocaleData | (() => Promise<LocaleData>);
    };
    selected?: string;
    alias?: Alias;
}
export interface LocalizedProviderState {
    localeReady: boolean;
}
